<?php


/*
Plugin Name: Blog in Blog
Plugin URI: http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/
Description: Create a blog within a blog using a category. This plugin basically shows posts in a category on a page using shortcodes.
Version: 0.5
Author: Tim Hodson
Author URI: http://informationtakesover.co.uk
*/
/*  Copyright 2009  Tim Hodson  (email : tim@timhodson.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
* [bloginblog category_id= num= ]
* Assume most recent first (it's supposed to be a mini blog)
*/

global $blog_in_blog_opts;

function bib_get_opts() {
	global $blog_in_blog_opts;

	$blog_in_blog_opts['display_dots_after'] = get_option('bib_show_dots_after');
	if ($blog_in_blog_opts['display_dots_after'] == '') {
		$blog_in_blog_opts['display_dots_after'] = 5;

		update_option('bib_show_dots_after', $blog_in_blog_opts['display_dots_after']);
	}

	$blog_in_blog_opts['delimiter'] = get_option('bib_text_delim');
	if ($blog_in_blog_opts['delimiter'] == '') {
		$blog_in_blog_opts['delimiter'] = ",";

		update_option('bib_text_delim', $blog_in_blog_opts['delimiter']);
	}

	$blog_in_blog_opts['page_text'] = get_option('bib_text_page');
	if ($blog_in_blog_opts['page_text'] == '') {
		$blog_in_blog_opts['page_text'] = 'Page';

		update_option('bib_text_page', $blog_in_blog_opts['page_text']);
	}

	$blog_in_blog_opts['prev_link_text'] = get_option('bib_text_previous');
	if ($blog_in_blog_opts['prev_link_text'] == '') {
		$blog_in_blog_opts['prev_link_text'] = '<<';

		update_option('bib_text_previous', $blog_in_blog_opts['prev_link_text']);
	}

	$blog_in_blog_opts['next_link_text'] = get_option('bib_text_next');
	if ($blog_in_blog_opts['next_link_text'] == '') {
		$blog_in_blog_opts['next_link_text'] = '>>';

		update_option('bib_text_next', $blog_in_blog_opts['next_link_text']);
	}
	$blog_in_blog_opts['style_selected'] = get_option('bib_style_selected');
	if ($blog_in_blog_opts['style_selected'] == '') {
		$blog_in_blog_opts['style_selected'] = 'font-weight:bold;';

		update_option('bib_style_selected', $blog_in_blog_opts['style_selected']);
	}
	$blog_in_blog_opts['style_not_selected'] = get_option('bib_style_not_selected');
	if ($blog_in_blog_opts['style_not_selected'] == '') {
		$blog_in_blog_opts['style_not_selected'] = 'color:grey;';

		update_option('bib_style_not_selected', $blog_in_blog_opts['style_not_selected']);
	}
	$blog_in_blog_opts['post_template'] = get_option('bib_post_template');
	if ($blog_in_blog_opts['post_template'] == '') {
		$blog_in_blog_opts['post_template'] = 'bib_post_template.tpl';

		update_option('bib_post_template', $blog_in_blog_opts['post_template']);
	}
	$blog_in_blog_opts['more_link_text'] = get_option('bib_more_link_text');
	if ($blog_in_blog_opts['more_link_text'] == '') {
		$blog_in_blog_opts['more_link_text'] = 'more &raquo;';

		update_option('bib_more_link_text', $blog_in_blog_opts['more_link_text']);
	}
}

bib_get_opts();

function blog_in_blog_func($atts) {
	global $blog_in_blog_opts;
	global $wp_query;

	extract(shortcode_atts(array (
		'category_id' => '1',
		'num' => '10',


	), $atts));

	$blog_in_blog_opts['cat'] = $category_id;
	$blog_in_blog_opts['num'] = $num;

	// get some posts for that category
	$out = "";

	$blog_in_blog_opts['offset'] = $wp_query->query['offset'];
	//	var_dump($wp_query->query);
	//	echo "offset : $nextoffset";

	$params = array (
		'numberposts' => $num,
		'orderby' => 'date',
		'order' => 'DESC',
		'offset' => $blog_in_blog_opts['offset'],
		'category' => $category_id
	);

	$postslist = get_posts($params);
	//	$postslist = get_posts(array_merge($params, $wp_query->query));
	foreach ($postslist as $post) {

		// could format the datetime too.
		$data['post_id'] = $post->ID;
		$data['post_date'] = strftime('%A %d %B, %Y', strtotime($post->post_date_gmt));
		$data['post_title'] = $post->post_title;
		$data['post_content'] = apply_filters('the_content', $post->post_content);
		$data['post_permalink'] = apply_filters('the_permalink', get_permalink($post));

		$data = bib_process_moretag($data);
		// use a configurable template for this?
		$out .= bib_parse_template($data);
	}

	$out .= blog_in_blog_page_navi();
	// func - get page navi

	// return the posts data.
	return $out;
}
add_shortcode('blog_in_blog', 'blog_in_blog_func');

/**
 * parse template string
 */
function bib_parse_template($data) {
	global $blog_in_blog_opts;
	//	echo "here";
	// get template string from options
	$template = file_get_contents(WP_PLUGIN_DIR . "/blog-in-blog/" . $blog_in_blog_opts['post_template']);

	//	$template = html_entity_decode($blog_in_blog_opts['bib_post_template']);
	// replace %date% %title% %permalink%
	$template = str_replace("%post_id%", $data['post_id'], $template);
	$template = str_replace("%post_date%", $data['post_date'], $template);
	$template = str_replace("%post_title%", $data['post_title'], $template);
	$template = str_replace("%post_content%", $data['post_content'], $template);
	$template = str_replace("%post_permalink%", $data['post_permalink'], $template);

	return $template;
}

/**
 * based on get_the_content() in wp-includes/post-template.php
 */
function bib_process_moretag($data) {
	global $blog_in_blog_opts;
	global $more, $multipage, $page;
	$more = 0;

	$output = '';
    $hasTeaser = false;
	$more_link_text = $blog_in_blog_opts['more_link_text'];

	if (preg_match('/<!--more(.*?)?-->/', $data['post_content'], $matches)) {
		$content = explode($matches[0], $data['post_content'], 2);
		if (!empty ($matches[1]) && !empty ($more_link_text))
			$more_link_text = strip_tags(wp_kses_no_null(trim($matches[1])));

		$hasTeaser = true;
		//$more = 0;

	} else {
		$content = array (
			$data['post_content']
		);
		// $more = 1;
	}

	if ((false !== strpos($data['post_content'], '<!--noteaser-->')) && ((!$multipage) || ($page == 1))) {
		$stripteaser = 1;

	}
	$teaser = $content[0];

	if (($more) && ($stripteaser) && ($hasTeaser)){
		//    if ( ($more) && ($hasTeaser) )

			$teaser = '';

	}

	$output .= $teaser;

	if (count($content) > 1) {
		if ($more) {

			$output .= '<span id="more-' . $data['post_id'] . '"></span>' . $content[1];
		} else {

			if (!empty ($more_link_text))
				$output .= apply_filters('the_content_more_link', ' <a href="' . $data['post_permalink'] . "#more-{$data['post_id']}'\" class=\"more-link\">$more_link_text</a>", $more_link_text);
			$output = force_balance_tags($output);
		}

	}

	$data['post_content'] = $output;
	return $data;

}

/**
 * Page navi
 */
function blog_in_blog_page_navi() {
	global $blog_in_blog_opts;

	// count pages in chosen category
	$catposts = bib_get_post_count();
	$num = $blog_in_blog_opts['num'];

	$dlimit = $blog_in_blog_opts['display_dots_after'];
	$elipsis = " ...";
	$page = 0;
	$maxpages = floor($catposts / $num);
	$nextoffset = 0;

	$out = '<div style="bib_page_nav">';

	// show page jumps for every $n posts
	for ($i = 0; $i < $catposts; $i++) {
		if ($i % $num == 0) {
			// start a new page, so
			$nextpage = $page++;
			$nextoffset = $thisloop;
			$thisloop++;
			if ($i +1 == $catposts) {
				$lastpage = true;
			}

			// check if this is the current page (based on offset, if offset not set is first page selected
			if ($match == false && (!isset ($blog_in_blog_opts['offset']) || $thisloop -1 == $blog_in_blog_opts['offset'])) {
				//				$selected = ' bib_selected" style="font-weight:bold;color:red;';
				$selected = ' bib_selected" style="' . $blog_in_blog_opts['style_selected'] . '"';

				$poffset = ($nextoffset - $num);
				$noffset = ($nextoffset + $num);
				$prevlink = ($nextoffset > 0) ? '<a href="' . get_permalink() . '&offset=' . $poffset . '">' . $blog_in_blog_opts['prev_link_text'] . '</a> ' : $blog_in_blog_opts['prev_link_text'] . ' ';
				$nextlink = ($noffset < $catposts) ? ' <a href="' . get_permalink() . '&offset=' . $noffset . '">' . $blog_in_blog_opts['next_link_text'] . '</a>' : ' ' . $blog_in_blog_opts['next_link_text'];

				$pages[$page]['current'] = true;
				$match = true;
			} else {
				$selected = ' bib_not_selected" style="' . $blog_in_blog_opts['style_not_selected'] . '"';
			}

			// if first page has been output
			if ($first == false) {
				$pout = $blog_in_blog_opts['page_text'] . ' <a href="' . get_permalink() . '" class="bib_page_number' . $selected . '" > ' . $page . '</a>' . $blog_in_blog_opts['delimiter'];
				$pages[$page]['html'] = $pout;
				$first = true;
			} else {
				// only output delimiter and page numbers
				if ($lastpage) {
					$pout = ' <a href="' . get_permalink() . '&offset=' . $nextoffset . '" class="bib_page_number' . $selected . '" >' . $page . '</a>';

				} else {
					$pout = ' <a href="' . get_permalink() . '&offset=' . $nextoffset . '" class="bib_page_number' . $selected . '" >' . $page . '</a>' . $blog_in_blog_opts['delimiter'];
				}
				$pages[$page]['html'] = $pout;
			}
		} else {
			$nextpage = $page;
			$thisloop++;
		}

		//echo "<br />$i, nextpage: $nextpage, thisloop: $thisloop, page: $page, nextoffset: $nextoffset, URLoffset: {$blog_in_blog_opts['offset']}";

		if ($thisloop == $nextpage) {
			// do what exactly?

		}

	}
	//	var_dump($pages);

	if (count($pages) > $dlimit) {
		$max = count($pages);

		$fp = $pages[1]['html'];
		$lp = $pages[$max]['html'];

		foreach ($pages as $k => $page) {
			if ($page['current']) {

				if ($k == 1 || $k == 2 || $k == 3) {
					$fp = '';
					$elipsisa = '';
				}
				elseif ($k == 4) {
					$elipsisa = $blog_in_blog_opts['delimiter'];
				} else {

					$elipsisa = $elipsis;
				}

				$precurr = $pages[$k -2]['html'];
				$precurr .= $pages[$k -1]['html'];
				$current = $pages[$k]['html'];
				$postcurr = $pages[$k +1]['html'];
				//				 trim delimiter from end of string.
				$postcurr .= substr($pages[$k +2]['html'], 0, strlen($pages[$k +2]['html']) - strlen($blog_in_blog_opts['delimiter']));

				if ($k == $max || $k == ($max -1) || $k == ($max -2)) {
					$lp = '';
					$elipsisb = '';
				}
				elseif ($k == ($max -3)) {
					$elipsisb = $blog_in_blog_opts['delimiter'];
				} else {

					$elipsisb = $elipsis;
				}
			}
		}

		$out .= $prevlink . $fp . $elipsisa . $precurr . $current . $postcurr . $elipsisb . $lp . $nextlink;
	} else {
		if (is_array($pages)) {
			foreach ($pages as $page) {
				$pagesout .= $page['html'];
			}
		}
		// remove trailing delimiter
		$pagesout = substr($pagesout, 0, strlen($pagesout) - strlen($blog_in_blog_opts['delimiter']));

		$out .= $prevlink . $pagesout . $nextlink;
	}

	$out .= '</div>';
	//	echo htmlspecialchars($out);
	// return HTML
	return $out;

}

function bib_get_post_count() {
	global $wpdb;
	global $blog_in_blog_opts;
	$post_count = 0;
	$categories = $blog_in_blog_opts['cat'];

	$querystr = "
							SELECT count
							FROM $wpdb->term_taxonomy, $wpdb->posts, $wpdb->term_relationships
							WHERE $wpdb->posts.ID = $wpdb->term_relationships.object_id
							AND $wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id
							AND $wpdb->term_taxonomy.term_id = $categories
							AND $wpdb->posts.post_status = 'publish'
						";
	//	echo $querystr;
	$result = $wpdb->get_var($querystr);
	//	echo $result;
	$post_count = $result;
	return $post_count;
}

add_filter('query_vars', 'bib_url_params');
function bib_url_params($qvars) {
	$qvars[] = 'offset';
	return $qvars;
}

/*
* Hide the category chosen to be the blog
*/

add_action('pre_get_posts', 'bib_hide_category');

function bib_hide_category($notused) {
	global $wp_query;

	$cat = get_option('bib_hide_category');
	if (is_home()) {
		//var_dump($cat);
		if (is_array($cat)) {

			foreach ($cat as $v) {

				if($v != "NONE"){
					$c .= '-' . $v . ',';
				}

			}
			$wp_query->query_vars['cat'] = $c;
		}
	}
}

// alternative way to hide categories directly in the template page
// if (is_home()) {
//  query_posts("cat=-8");
//}

/**
 * =========================================================
 * Add options to admin menu
 */

add_option('bib_hide_category');

add_action('admin_menu', 'blog_in_blog_menu');

function blog_in_blog_menu() {
	add_options_page('blog in blog Options', 'Blog-in-Blog', 8, __FILE__, 'blog_in_blog_options');
}

function blog_in_blog_options() {
	$out = "";
	$out .= '<div class="wrap">';
	$out .= '<h2>Blog-in-Blog</h2>';
	$out .= '<p>See full notes at <a href="http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/">http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/</a></p>';

	$out .= '<form method="post" action="options.php">';
	$out .= wp_nonce_field('update-options');
	$out .= '<style type="text/css">.form-table td {width:80px;}</style>';
	$out .= '<table class="form-table">';

	// categories to hide
	$out .= '<tr valign="top" ><th scope="row">Category id to hide from homepage</th><td>';
	$select = '<select name="bib_hide_category[]" multiple="multiple" size="6" style="height:auto;">';

	$catselected = get_option('bib_hide_category');
	if (!is_array($catselected)) {
		$catselected = array($catselected);
	}
//var_dump($catselected);

	$categories = get_categories();

	if (is_array($categories)) {

		foreach ($categories as $cat) {

			if (in_array($cat->cat_ID, $catselected)) {
				$select .= '<option value="' . $cat->cat_ID . '" selected="selected" >';
				$select .= $cat->cat_name . ' (category_id:' . $cat->cat_ID;
				$select .= ', ' . $cat->category_count . ' posts)';
				$select .= '</option>';

			} else {
				$select .= '<option value="' . $cat->cat_ID . '">';
				$select .= $cat->cat_name . ' (category_id:' . $cat->cat_ID;
				$select .= ', ' . $cat->category_count . ' posts)';
				$select .= '</option>';
			}

		}
	}
	$select .= '<option value="NONE">Show all categories</option>';
	$select .= '</select>';
	$out .= $select . '</td></tr>';

	// show dots after n pages
	$out .= '<tr valign="top"><th scope="row">Show dots (elipsis) after n pages</th><td><input type="text" name="bib_show_dots_after" value="' . get_option('bib_show_dots_after') . '" /></td></tr>';

	// previous linkn text
	$out .= '<tr valign="top"><th scope="row">Text to show as "previous page" link</th><td><input type="text" name="bib_text_previous" value="' . get_option('bib_text_previous') . '" /></td></tr>';

	// next link text
	$out .= '<tr valign="top"><th scope="row">Text to show as "next page" link</th><td><input type="text" name="bib_text_next" value="' . get_option('bib_text_next') . '" /></td></tr>';

	// text preceeding page 1
	$out .= '<tr valign="top"><th scope="row">Text to show preceeding page 1. e.g. Post (Post 1, 2, 3) or Page (Page 1, 2, 3) etc</th><td><input type="text" name="bib_text_page" value="' . get_option('bib_text_page') . '" /></td></tr>';

	// delimiter
	$out .= '<tr valign="top"><th scope="row">The characters to show between page links, e.g. "," or "|"</th><td><input type="text" name="bib_text_delim" value="' . get_option('bib_text_delim') . '" /></td></tr>';

	// Style selected
	$out .= '<tr valign="top"><th scope="row">Style for current page e.g. font-weight:bold;</th><td><input type="text" name="bib_style_selected" value="' . get_option('bib_style_selected') . '" /></td></tr>';
	// Style not selected
	$out .= '<tr valign="top"><th scope="row">Style for non current page e.g. color:grey;</th><td><input type="text" name="bib_style_not_selected" value="' . get_option('bib_style_not_selected') . '" /></td></tr>';
	// template file
	$out .= '<tr valign="top"><th scope="row">The name of the template for a category post. If not set will default to /wp_plugins/blog-in-blog/bib_post_template.tpl default serves as an example.</th><td><input type="text" name="bib_post_template" value="' . get_option('bib_post_template') . '" /></td></tr>';

	// more_link_text
	$out .= '<tr valign="top"><th scope="row">Text for the more link if you use the &lt;!--more--&gt; tag in your posts.</th><td><input type="text" name="bib_more_link_text" value="' . get_option('bib_more_link_text') . '" /></td></tr>';

	$out .= '</table>';

	$out .= '<input type="hidden" name="action" value="update" />';
	$out .= '<input type="hidden" name="page_options" value="bib_hide_category,bib_show_dots_after,bib_text_previous,bib_text_next,bib_text_page,bib_text_delim,bib_post_template,bib_style_selected,bib_style_not_selected,bib_more_link_text" />';

	$out .= '<p class="submit">';
	$out .= '<input type="submit" class="button-primary" value="Save Changes" />';
	$out .= '</p>';

	$out .= '</form>';
	$out .= '</div>';

	echo $out;
}
?>
